#ifndef PROJECTILES_HPP_INCLUDED
#define PROJECTILES_HPP_INCLUDED

#include "../../Game/Interactable/Projectile.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

class Projectiles
{
    public:

        static std::vector<Interactable::Projectile> GetAllWithin(std::int32_t Distance);
        static std::vector<Interactable::Projectile> GetAll();

        static std::vector<Interactable::Projectile> GetAll(const Tile& T);
        static std::vector<Interactable::Projectile> GetAll(std::int32_t ID, std::int32_t Distance = -1);
        static std::vector<Interactable::Projectile> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static std::vector<Interactable::Projectile> GetAll(const std::function<bool (Interactable::Projectile&)>& Filter, std::int32_t Distance = -1);

        static Interactable::Projectile Get(const Tile& T);
        static Interactable::Projectile Get(std::int32_t ID, std::int32_t Distance = -1);
        static Interactable::Projectile Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static Interactable::Projectile Get(const std::function<bool (Interactable::Projectile&)>& Filter, std::int32_t Distance = -1);
};


#endif // PROJECTILES_HPP_INCLUDED
